package au.com.infomedix.cpf4.ds;

import java.io.File;
import java.util.Collection;

import javax.inject.Inject;

import org.jboss.arquillian.container.test.api.Deployment;
import org.jboss.arquillian.junit.Arquillian;
import org.jboss.shrinkwrap.api.GenericArchive;
import org.jboss.shrinkwrap.api.ShrinkWrap;
import org.jboss.shrinkwrap.api.asset.EmptyAsset;
import org.jboss.shrinkwrap.api.spec.JavaArchive;
import org.jboss.shrinkwrap.resolver.api.DependencyResolvers;
import org.jboss.shrinkwrap.resolver.api.maven.MavenDependencyResolver;
import org.junit.Test;
import org.junit.runner.RunWith;


@RunWith(Arquillian.class)
public class TestPatientRecordOperation
{
    @Inject
    private PatientRecordOperation poService;

    @Deployment
    //@OverProtocol("Servlet 3.0")
    public static JavaArchive createTestArchive()
    {
        System.out.println("Create bean archive");

        JavaArchive jar = ShrinkWrap.create(JavaArchive.class, "TestPatientRecordOperation.jar").addClasses(PatientRecordOperation.class).addAsManifestResource(EmptyAsset.INSTANCE,
                                                                                                                                                                "beans.xml");

//
//        System.out.println("Create maven deps archive");
//
//        Collection<GenericArchive> mavenDeps = DependencyResolvers.use(MavenDependencyResolver.class)
//                                                                  .loadMetadataFromPom("pom.xml")
//                                                                  //.exclusions("org.jboss.solder:solder-api","org.jboss.solder:solder-logging","org.jboss.solder:solder-impl","org.jboss.shrinkwrap:shrinkwrap-api","org.jboss.shrinkwrap:shrinkwrap-spi","org.jboss.shrinkwrap:shrinkwrap-impl-base")
//                                                                  .resolveAs(GenericArchive.class);
//
//        for(GenericArchive ar : mavenDeps)
//        {
//            System.out.println("maven deps archive contains: " + ar.toString(false));
//            System.out.println("Merge archives");
//            jar = jar.merge(ar);
//        }
//
        jar.addAsManifestResource(new File("src/test/resources/jboss-deployment-structure.xml"), "jboss-deployment-structure.xml");

        System.out.println("jar: " + jar.toString(true));

        return jar;
    }

    @Test
    public void test()
    {
        poService.addPatient("IHE", "919191");
    }
}